JUCE: StringPool Class Reference

JUCE

Public Member Functions | Static Public Member Functions | List of all members
StringPool Class Reference

A StringPool holds a set of shared strings, which reduces storage overheads and improves comparison speed when dealing with many duplicate strings. More...

## Public Member Functions
| StringPool () noexcept
| Creates an empty pool. More...
| ~StringPool ()
| Destructor. More...
String | getPooledString (const String &original)
| Returns a pointer to a shared copy of the string that is passed in. More...
String | getPooledString (const char *original)
| Returns a pointer to a copy of the string that is passed in. More...
String | getPooledString (StringRef original)
| Returns a pointer to a shared copy of the string that is passed in. More...
String | getPooledString (String::CharPointerType start, String::CharPointerType end)
| Returns a pointer to a copy of the string that is passed in. More...
void | garbageCollect ()
| Scans the pool, and removes any strings that are unreferenced. More...

## Static Public Member Functions
static StringPool & | getGlobalPool () noexcept
| Returns a shared global pool which is used for things like Identifiers, XML parsing. More...

## Detailed Description

A StringPool holds a set of shared strings, which reduces storage overheads and improves comparison speed when dealing with many duplicate strings.

When you add a string to a pool using getPooledString, it'll return a character array containing the same string. This array is owned by the pool, and the same array is returned every time a matching string is asked for. This means that it's trivial to compare two pooled strings for equality, as you can simply compare their pointers. It also cuts down on storage if you're using many copies of the same string.

## Constructor & Destructor Documentation

## ◆ StringPool()

StringPool::StringPool | ( |  | ) |
| noexcept

Creates an empty pool.

## ◆ ~StringPool()

StringPool::~StringPool | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ getPooledString() [1/4]

String StringPool::getPooledString | ( | const String & | original | ) |

Returns a pointer to a shared copy of the string that is passed in.

The pool will always return the same String object when asked for a string that matches it.

## ◆ getPooledString() [2/4]

String StringPool::getPooledString | ( | const char * | original | ) |

Returns a pointer to a copy of the string that is passed in.

The pool will always return the same String object when asked for a string that matches it.

## ◆ getPooledString() [3/4]

String StringPool::getPooledString | ( | StringRef | original | ) |

Returns a pointer to a shared copy of the string that is passed in.

The pool will always return the same String object when asked for a string that matches it.

## ◆ getPooledString() [4/4]

String StringPool::getPooledString | ( | String::CharPointerType | start,
|  | String::CharPointerType | end
| ) |  |

Returns a pointer to a copy of the string that is passed in.

The pool will always return the same String object when asked for a string that matches it.

## ◆ garbageCollect()

void StringPool::garbageCollect | ( |  | ) |

Scans the pool, and removes any strings that are unreferenced.

You don't generally need to call this - it'll be called automatically when the pool grows large enough to warrant it.

## ◆ getGlobalPool()

static StringPool& StringPool::getGlobalPool | ( |  | ) |
| staticnoexcept

Returns a shared global pool which is used for things like Identifiers, XML parsing.

The documentation for this class was generated from the following file:

- juce_StringPool.h